diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 3fe26f5b6..d7db4cc43 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -16,6 +16,8 @@ import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.particle.Particle;
 import net.minecraft.client.render.particle.ParticleDispatcher;
 import net.minecraft.client.render.particle.ParticleEntry;
+import net.minecraft.client.render.particle.ParticleSiphon;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
@@ -230,6 +232,7 @@ public final class RenderGlobal
         world.addListener(this);
         AURORA_PROVIDER.init(world);
         this.allChanged();
+        this.mc.terrainRenderer.resetChunkSorting();
     }
 
     public void allChanged() {
@@ -923,159 +926,194 @@ public final class RenderGlobal
         GLRenderer.popFrame();
     }
 
+    private @Nullable RenderBuffer cloudBuffer;
+    private int cachedRadius = -1;
+
     public void renderCloudsFancy(float partialTick) {
         GLRenderer.pushFrame();
         GLRenderer.setLightmapCoord2i(15, 15);
+        assert this.mc.currentWorld != null;
         WorldTypeFX worldTypeFX = WorldTypeFXDispatcher.getInstance().getDispatch(this.mc.currentWorld.getWorldType());
         this.mc.renderer.beginRenderClouds(partialTick);
-
-        float celestialAngle = this.world.getCelestialAngle(partialTick);
+        float celestialAngle = world.getCelestialAngle(partialTick);
         float[] sunriseColor = worldTypeFX.getSunriseColor(celestialAngle, partialTick);
-        float rSun = 0.0f, gSun = 0.0f, bSun = 0.0f, aSun = 0.0f;
+        float rSun = 0.0F;
+        float gSun = 0.0F;
+        float bSun = 0.0F;
+        float aSun = 0.0F;
         if (sunriseColor != null) {
             rSun = sunriseColor[0];
             gSun = sunriseColor[1];
             bSun = sunriseColor[2];
-            aSun = sunriseColor[3] / 2;
+            aSun = sunriseColor[3] / 2.0F;
         }
 
-        Vector3fc dimensionColor = this.world.getDimensionColor(this.mc.activeCamera, partialTick);
-        final float rDim = dimensionColor.x();
-        final float gDim = dimensionColor.y();
-        final float bDim = dimensionColor.z();
+        Vector3fc dimensionColor = world.getDimensionColor(this.mc.activeCamera, partialTick);
+        float rDim = dimensionColor.x();
+        float gDim = dimensionColor.y();
+        float bDim = dimensionColor.z();
 
         GLRenderer.disableState(State.CULL_FACE);
-        float cameraY = (float) this.mc.activeCamera.getY(partialTick);
-        TessellatorShader tessellator = GLRenderer.getTessellator();
-        float ss = 12F;
-        float h = 4F;
-        double xo = (this.mc.activeCamera.getX(partialTick) + (double) ((this.lastCloudOffsetX + (this.cloudOffsetX - this.lastCloudOffsetX) * partialTick) * 0.03F)) / (double) ss;
-        double zo = (this.mc.activeCamera.getZ(partialTick) + (double) ((this.lastCloudOffsetZ + (this.cloudOffsetZ - this.lastCloudOffsetZ) * partialTick) * 0.03F)) / (double) ss + 0.33D;
-        float yy = (worldTypeFX.getCloudHeight(this.world) - cameraY) + 0.33F + getCloudHeightModifier();
-        int xOffs = MathHelper.floor(xo / 2048D);
-        int zOffs = MathHelper.floor(zo / 2048D);
+
+        float cameraY = (float)this.mc.activeCamera.getY(partialTick);
+
+        float modelScale = 12.0F;
+        float deltaHeight = 4.0F;
+        ICamera camera = mc.activeCamera;
+
+        double xo = (camera.getX(partialTick) + (lastCloudOffsetX + (cloudOffsetX - lastCloudOffsetX) * partialTick) * 0.03F) / modelScale;
+        double zo = (camera.getZ(partialTick) + (lastCloudOffsetZ + (cloudOffsetZ - lastCloudOffsetZ) * partialTick) * 0.03F) / modelScale + 0.33;
+        float cloudMinY = worldTypeFX.getCloudHeight(this.world) - cameraY + 0.33F + getCloudHeightModifier();
+        int xOffs = MathHelper.floor(xo / 2048.0);
+        int zOffs = MathHelper.floor(zo / 2048.0);
         xo -= xOffs * 2048;
         zo -= zOffs * 2048;
 
-        boolean noBFCMode = ( (yy > -h - 1) && (yy <= h + 1) );
-        if( noBFCMode ) {
+        boolean noBFCMode = cloudMinY > -deltaHeight - 1.0F && cloudMinY <= deltaHeight + 1.0F;
+
+        if (noBFCMode) {
             GLRenderer.disableState(State.CULL_FACE);
-        }
-        else {
+        } else {
             GLRenderer.enableState(State.CULL_FACE);
         }
 
         this.textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-        float scale = 1F / 256F;
-        float uo = (float) MathHelper.floor(xo) * scale;
-        float vo = (float) MathHelper.floor(zo) * scale;
-        float xoffs2 = (float) (xo - (double) MathHelper.floor(xo));
-        float zoffs2 = (float) (zo - (double) MathHelper.floor(zo));
-        final int D = 8;
-        final byte radius = (byte) Math.max(1, 3 * GameSettings.CLOUD_RENDER_DISTANCE.value);
-        float e = 1F / 1024F;
-        GLRenderer.modelM4f().scale(ss, 1.0F, ss);
+        float scale = 0.00390625F;
+
+        float xOffset = (float)xo;
+        float zOffset = (float)zo;
 
+        byte radius = (byte)Math.max(1.0F, 3.0F * GameSettings.CLOUD_RENDER_DISTANCE.value);
         float red = rDim + (rSun - rDim) * aSun;
         float green = gDim + (gSun - gDim) * aSun;
         float blue = bDim + (bSun - bDim) * aSun;
 
-        tessellator.startDrawingQuads();
-        {
-            float width = (radius * 2 + 2) * D;
-            float xx = (-radius - 1) * D;
-            float zz = (-radius - 1) * D;
-            float xp = xx - xoffs2;
-            float zp = zz - zoffs2;
-            if (yy > -h - 1.0F) {
-                tessellator.setColor4f(red * 0.7F, green * 0.7F, blue * 0.7F, 0.8F);
-                tessellator.setNormal(0.0F, -1F, 0.0F);
-                tessellator.addVertexWithUV(xp + 0.0F, yy + 0.0F, zp + 0.0F, (xx + 0.0F) * scale + uo, (zz + 0.0F) * scale + vo);
-                tessellator.addVertexWithUV(xp + width, yy + 0.0F, zp + 0.0F, (xx + width) * scale + uo, (zz + 0.0F) * scale + vo);
-                tessellator.addVertexWithUV(xp + width, yy + 0.0F, zp + width, (xx + width) * scale + uo, (zz + width) * scale + vo);
-                tessellator.addVertexWithUV(xp + 0.0F, yy + 0.0F, zp + width, (xx + 0.0F) * scale + uo, (zz + width) * scale + vo);
-            }
-            if (yy <= h + 1.0F) {
-                tessellator.setColor4f(red, green, blue, 0.8F);
-                tessellator.setNormal(0.0F, 1.0F, 0.0F);
-                tessellator.addVertexWithUV(xp + 0.0F, (yy + h) - e, zp + 0.0F, (xx + 0.0F) * scale + uo, (zz + 0.0F) * scale + vo);
-                tessellator.addVertexWithUV(xp + 0.0F, (yy + h) - e, zp + width, (xx + 0.0F) * scale + uo, (zz + width) * scale + vo);
-                tessellator.addVertexWithUV(xp + width, (yy + h) - e, zp + width, (xx + width) * scale + uo, (zz + width) * scale + vo);
-                tessellator.addVertexWithUV(xp + width, (yy + h) - e, zp + 0.0F, (xx + width) * scale + uo, (zz + 0.0F) * scale + vo);
+        boolean needsRebuild = this.cloudBuffer == null || radius != cachedRadius;
+        if (needsRebuild) {
+            if (cloudBuffer != null) {
+                cloudBuffer.delete();
             }
+            cloudBuffer = meshFancyClouds(
+                    deltaHeight,
+                    scale,
+                    radius
+            );
+            cachedRadius = radius;
         }
-        for (int ix = -radius - 1; ix <= radius + 1; ix++) {
-            for (int iz = -radius - 1; iz <= radius + 1; iz++) {
-                float xx = ix * D;
-                float zz = iz * D;
-                float cloudX = xx - xoffs2;
-                float cloudZ = zz - zoffs2;
-                tessellator.setColor4f(red * 0.9F, green * 0.9F, blue * 0.9F, 0.8F);
-                if (ix > -1) {
-                    tessellator.setNormal(-1F, 0.0F, 0.0F);
-                    for (int s = 0; s < D; s++) {
-                        final float u = (xx + s + 0.5F) * scale + uo;
-                        tessellator.addVertexWithUV(cloudX + s + 0.0F, yy + 0.0F, cloudZ + 0.0F, u, (zz + 0.0F) * scale + vo);
-                        tessellator.addVertexWithUV(cloudX + s + 0.0F, yy + 0.0F, cloudZ + D, u, (zz + D) * scale + vo);
-                        tessellator.addVertexWithUV(cloudX + s + 0.0F, yy + h, cloudZ + D, u, (zz + D) * scale + vo);
-                        tessellator.addVertexWithUV(cloudX + s + 0.0F, yy + h, cloudZ + 0.0F, u, (zz + 0.0F) * scale + vo);
+
+        GLRenderer.modelM4f()
+                .translate(0.0F, cloudMinY, 0.0F)
+                .scale(modelScale, 1.0F, modelScale);
+
+        GLRenderer.setShader(Shaders.CLOUDS);
+        GLRenderer.globalSetUniforms(Shaders.CLOUDS);
+
+        GLRenderer.getShader().uniformFloat("xOffset", xOffset);
+        GLRenderer.getShader().uniformFloat("zOffset", zOffset);
+//        GLRenderer.getShader().uniformVec3f("uColor", red, green, blue);
+        GLRenderer.setColor3f(red, green, blue);
+
+        GLRenderer.setColorMask(false, false, false, true);
+        GLRenderer.render(this.cloudBuffer);
+        GLRenderer.setColorMask(true, true, true, true);
+
+        GLRenderer.render(this.cloudBuffer);
+
+        GLRenderer.popFrame();
+        this.mc.renderer.endRenderClouds(partialTick);
+    }
+
+    private RenderBuffer meshFancyClouds(
+            float deltaHeight,
+            float scale,
+            byte radius
+    ) {
+        TessellatorShader tessellator = GLRenderer.getTessellator();
+
+        float e = 9.765625E-4F;
+        tessellator.startDrawingQuads();
+        float width = (radius * 2 + 2) * 8;
+        float scaledX = (-radius - 1) * 8;
+        float scaledZ = (-radius - 1) * 8;
+        float adjustedX = scaledX;
+        float adjustedZ = scaledZ;
+
+        // Bottom faces
+        tessellator.setColor4f(0.7F, 0.7F, 0.7F, 0.8F);
+        tessellator.setNormal(0.0F, -1.0F, 0.0F);
+        tessellator.addVertexWithUV(adjustedX, 0.0F, adjustedZ, scaledX * scale, scaledZ * scale);
+        tessellator.addVertexWithUV(adjustedX + width, 0.0F, adjustedZ, (scaledX + width) * scale, scaledZ * scale);
+        tessellator.addVertexWithUV(adjustedX + width, 0.0F, adjustedZ + width, (scaledX + width) * scale, (scaledZ + width) * scale);
+        tessellator.addVertexWithUV(adjustedX, 0.0F, adjustedZ + width, scaledX * scale, (scaledZ + width) * scale);
+
+        // Top faces
+        tessellator.setColor4f(1, 1, 1, 0.8F);
+        tessellator.setNormal(0.0F, 1.0F, 0.0F);
+        tessellator.addVertexWithUV(adjustedX, deltaHeight - e, adjustedZ, scaledX * scale, scaledZ * scale);
+        tessellator.addVertexWithUV(adjustedX, deltaHeight - e, adjustedZ + width, scaledX * scale, (scaledZ + width) * scale);
+        tessellator.addVertexWithUV(adjustedX + width, deltaHeight - e, adjustedZ + width, (scaledX + width) * scale, (scaledZ + width) * scale);
+        tessellator.addVertexWithUV(adjustedX + width, deltaHeight - e, adjustedZ, (scaledX + width) * scale, scaledZ * scale);
+
+        // Side faces
+        for (int x = -radius - 1; x <= radius + 1; x++) {
+            for (int z = -radius - 1; z <= radius + 1; z++) {
+                scaledZ = x * 8;
+                adjustedX = z * 8;
+                adjustedZ = scaledZ;
+
+                float cloudZ = adjustedX;
+
+                tessellator.setColor4f(0.9F, 0.9F, 0.9F, 0.8F);
+                if (x > -1) {
+                    tessellator.setNormal(-1.0F, 0.0F, 0.0F);
+                    for (int delta = 0; delta < 8; delta++) {
+                        float u = (scaledZ + delta + 0.5F) * scale;
+                        tessellator.addVertexWithUV(adjustedZ + delta, 0.0F, cloudZ, u, adjustedX * scale);
+                        tessellator.addVertexWithUV(adjustedZ + delta, 0.0F, cloudZ + 8.0F, u, (adjustedX + 8.0F) * scale);
+                        tessellator.addVertexWithUV(adjustedZ + delta, deltaHeight, cloudZ + 8.0F, u, (adjustedX + 8.0F) * scale);
+                        tessellator.addVertexWithUV(adjustedZ + delta, deltaHeight, cloudZ, u, adjustedX * scale);
                     }
                 }
 
-                if (ix <= 1) {
+                if (x <= 1) {
                     tessellator.setNormal(1.0F, 0.0F, 0.0F);
-                    for (int s = 0; s < D; s++) {
-                        final float u = (xx + s + 0.5F) * scale + uo;
-                        tessellator.addVertexWithUV((cloudX + s + 1.0F) - e, yy + 0.0F, cloudZ + 0.0F, u, (zz + 0.0F) * scale + vo);
-                        tessellator.addVertexWithUV((cloudX + s + 1.0F) - e, yy + h, cloudZ + 0.0F, u, (zz + 0.0F) * scale + vo);
-                        tessellator.addVertexWithUV((cloudX + s + 1.0F) - e, yy + h, cloudZ + D, u, (zz + D) * scale + vo);
-                        tessellator.addVertexWithUV((cloudX + s + 1.0F) - e, yy + 0.0F, cloudZ + D, u, (zz + D) * scale + vo);
+                    for (int delta = 0; delta < 8; delta++) {
+                        float u = (scaledZ + delta + 0.5F) * scale;
+                        tessellator.addVertexWithUV(adjustedZ + delta + 1.0F - e, 0.0F, cloudZ, u, adjustedX * scale);
+                        tessellator.addVertexWithUV(adjustedZ + delta + 1.0F - e, deltaHeight, cloudZ, u, adjustedX * scale);
+                        tessellator.addVertexWithUV(adjustedZ + delta + 1.0F - e, deltaHeight, cloudZ + 8.0F, u, (adjustedX + 8.0F) * scale);
+                        tessellator.addVertexWithUV(adjustedZ + delta + 1.0F - e, 0.0F, cloudZ + 8.0F, u, (adjustedX + 8.0F) * scale);
                     }
                 }
 
-                tessellator.setColor4f(red * 0.8F, green * 0.8F, blue * 0.8F, 0.8F);
-                tessellator.setNormal(0.0F, 0.0F, -1F);
-                if (iz > -1) {
-                    for (int s = 0; s < D; s++) {
-                        final float v = (zz + s + 0.5F) * scale + vo;
-                        tessellator.addVertexWithUV(cloudX + 0.0F, yy + 0.0F, cloudZ + s + 0.0F, (xx + 0.0F) * scale + uo, v);
-                        tessellator.addVertexWithUV(cloudX + 0.0F, yy + h, cloudZ + s + 0.0F, (xx + 0.0F) * scale + uo, v);
-                        tessellator.addVertexWithUV(cloudX + D, yy + h, cloudZ + s + 0.0F, (xx + D) * scale + uo, v);
-                        tessellator.addVertexWithUV(cloudX + D, yy + 0.0F, cloudZ + s + 0.0F, (xx + D) * scale + uo, v);
+                tessellator.setColor4f(0.8F, 0.8F, 0.8F, 0.8F);
+                tessellator.setNormal(0.0F, 0.0F, -1.0F);
+                if (z > -1) {
+                    for (int s = 0; s < 8; s++) {
+                        float v = (adjustedX + s + 0.5F) * scale;
+                        tessellator.addVertexWithUV(adjustedZ, 0.0F, cloudZ + s, scaledZ * scale, v);
+                        tessellator.addVertexWithUV(adjustedZ, deltaHeight, cloudZ + s, scaledZ * scale, v);
+                        tessellator.addVertexWithUV(adjustedZ + 8.0F, deltaHeight, cloudZ + s, (scaledZ + 8.0F) * scale, v);
+                        tessellator.addVertexWithUV(adjustedZ + 8.0F, 0.0F, cloudZ + s, (scaledZ + 8.0F) * scale, v);
                     }
                 }
 
                 tessellator.setNormal(0.0F, 0.0F, 1.0F);
-                if (iz <= 1) {
-                    for (int s = 0; s < D; s++) {
-                        final float v = (zz + s + 0.5F) * scale + vo;
-                        tessellator.addVertexWithUV(cloudX + 0.0, yy + 0.0, (cloudZ + s + 1.0) - e, (xx + 0.0) * scale + uo, v);
-                        tessellator.addVertexWithUV(cloudX + D, yy + 0.0, (cloudZ + s + 1.0) - e, (xx + D) * scale + uo, v);
-                        tessellator.addVertexWithUV(cloudX + D, yy + h, (cloudZ + s + 1.0) - e, (xx + D) * scale + uo, v);
-                        tessellator.addVertexWithUV(cloudX + 0., yy + h, (cloudZ + s + 1.0) - e, (xx + 0.0) * scale + uo, v);
+                if (z <= 1) {
+                    for (int delta = 0; delta < 8; delta++) {
+                        float v = (adjustedX + delta + 0.5F) * scale;
+                        tessellator.addVertexWithUV(adjustedZ, 0.0F, cloudZ + delta + 1.0 - e, scaledZ * scale, v);
+                        tessellator.addVertexWithUV(adjustedZ + 8.0F, 0.0F, cloudZ + delta + 1.0 - e, (scaledZ + 8.0F) * scale, v);
+                        tessellator.addVertexWithUV(adjustedZ + 8.0F, deltaHeight, cloudZ + delta + 1.0 - e, (scaledZ + 8.0F) * scale, v);
+                        tessellator.addVertexWithUV(adjustedZ, deltaHeight, cloudZ + delta + 1.0 - e, scaledZ * scale, v);
                     }
                 }
-
             }
-
         }
-        GLRenderer.setShader(Shaders.CLOUDS);
-        GLRenderer.setColorMask(false, false, false, true);
-        tessellator.draw();
-
-        // Hack for not needing to record the cloud buffer twice
-        GLRenderer.setColorMask(true, true, true, true);
-        GLRenderer.getShader().bind();
-        GL41.glBindVertexArray(tessellator.vaos[tessellator.config]);
-        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, tessellator.vbos[tessellator.config]);
-        GL41.glDrawArrays(tessellator.drawMode.cap, 0, tessellator.vertexCount);
-        GL41.glBindVertexArray(0);
-
 
-        GLRenderer.popFrame();
-        this.mc.renderer.endRenderClouds(partialTick);
+        return tessellator.record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
     }
 
     private final DirtyChunkRendererSorter dirtyChunkRendererSorter = new DirtyChunkRendererSorter();
@@ -1879,6 +1917,39 @@ public final class RenderGlobal
         addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data, 16D, serverSided);
     }
 
+    private void spawnSiphonParticle(
+        @NotNull TilePos meshPos, @NotNull Direction face,
+        double minRadius, double radiusRange,
+        double minDepth, double depthRange,
+        @NotNull ParticleSiphon.Look look)
+    {
+
+        final java.util.Random rand = this.world.rand;
+
+        double angle = rand.nextDouble() * java.lang.Math.PI * 2.0;
+        double radius = minRadius + rand.nextDouble() * radiusRange;
+        double depth = minDepth + rand.nextDouble() * depthRange;
+
+        double offA = java.lang.Math.cos(angle) * radius;
+        double offB = java.lang.Math.sin(angle) * radius;
+
+        double px = meshPos.x + 0.5 + face.offsetX() * (0.5 + depth);
+        double py = meshPos.y + 0.5 + face.offsetY() * (0.5 + depth);
+        double pz = meshPos.z + 0.5 + face.offsetZ() * (0.5 + depth);
+
+        switch (face.axis()) {
+            case Y -> { px += offA; pz += offB; }
+            case Z -> { px += offA; py += offB; }
+            default -> { py += offA; pz += offB; }
+        }
+
+        if (this.world.getBlockMaterial(new TilePos(px, py, pz)) != Materials.WATER) {
+            return;
+        }
+
+        this.mc.particleEngine.add(new ParticleSiphon(this.world, px, py, pz, meshPos, face, this.world.dimension, look));
+    }
+
     @Override
     public void addParticle(String particleId, double x, double y, double z,
                             double motionX, double motionY, double motionZ, int data, double maxDistance, boolean serverSided) {
@@ -2044,6 +2115,27 @@ public final class RenderGlobal
 
                 break;
 
+            case EVENT_MESH_SIPHON_PARTICLES: // Mesh siphon funnel
+
+                Direction meshFace = Direction.fromIdOrDefault(null, data);
+                if (meshFace == null) break;
+
+                TilePos meshPos = new TilePos(x, y, z);
+
+                for (int i = 0; i < 2; i++) {
+                    spawnSiphonParticle(meshPos, meshFace, 0.10, 0.32, 0.10, 0.80, ParticleSiphon.Look.BUBBLE);
+                }
+
+                if (random.nextInt(2) == 0) {
+                    spawnSiphonParticle(meshPos, meshFace, 0.10, 0.30, 0.15, 0.65, ParticleSiphon.Look.SPLASH);
+                }
+
+                for (int i = 0; i < 2; i++) {
+                    spawnSiphonParticle(meshPos, meshFace, 0.06, 0.32, 0.03, 0.16, ParticleSiphon.Look.BUBBLE);
+                }
+
+                break;
+
             case EVENT_ACID_SPREAD:
                 this.world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "tile.acidbubble", 0.75F, 1.0F);
                 this.world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 3bb84b6bb..2e3339d3c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -259,7 +259,6 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_OAK_MOSSY, loadDataModel("minecraft:block/log/oak_mossy")));
         addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_THORN, loadDataModel("minecraft:block/log/thorn")));
         addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_PALM, loadDataModel("minecraft:block/log/palm")));
-        addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_PETRIFIED, loadDataModel("minecraft:block/log/petrified")));
 
         addDispatch(new BlockModelGenericLeaves<>(Blocks.LEAVES_OAK, "minecraft:block/leaves/oak"));
         addDispatch(new BlockModelGenericLeaves<>(Blocks.LEAVES_OAK_RETRO, "minecraft:block/leaves/oak_retro"));
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index 28ea1fa62..150f2615e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
@@ -7,6 +8,11 @@ import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.animal.MobButterfly;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.world.pos.TilePos;
@@ -328,6 +334,77 @@ public abstract class EntityRenderer<T extends Entity> {
         }
     }
 
+    private boolean isCharSequenceBlank(CharSequence cs) {
+        if (cs == null || cs.isEmpty()) {
+            return true;
+        }
+        for (int i = 0; i < cs.length(); i++) {
+            final char c = cs.charAt(i);
+            if (c == TextFormatting.SPECIAL_CHAR) {
+                i++;
+                continue;
+            }
+            if (!Character.isWhitespace(c) && !Character.isSpaceChar(c)) {
+                return false;
+            }
+        }
+        return true;
+    }
+
+    protected void renderLivingLabel(final @NotNull TessellatorGeneral t, final @NotNull T entity, final @NotNull CharSequence text, final double x, final double y, final double z, final int maxDistance, final boolean depthTest) {
+
+        boolean holdingLabel = false;
+        if (Minecraft.getMinecraft().thePlayer != null) {
+            ItemStack heldStack = Minecraft.getMinecraft().thePlayer.getHeldItem();
+            if (heldStack != null) {
+                holdingLabel = heldStack.getItem() == Items.LABEL;
+            }
+        }
+
+        if (!holdingLabel && isCharSequenceBlank(text)) {
+            return;
+        }
+
+
+        final float cameraDistance = (float) Minecraft.getMinecraft().activeCamera.distanceTo(entity);
+        if (cameraDistance > maxDistance) {
+            return;
+        }
+        final FontRenderer sr = getFont();
+        final float scale = 1.6f / 60f;
+
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y + entity.getHeadHeight() + 0.8f, (float) z);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(-this.renderDispatcher.viewLerpYaw));
+        GLRenderer.modelM4f().rotateX(Math.toRadians(this.renderDispatcher.viewLerpPitch));
+        GLRenderer.modelM4f().scale(-scale, -scale, scale);
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.setDepthMask(false);
+        if (!depthTest) GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        t.startDrawingQuads();
+        final int halfTextWidth = sr.stringWidth(text) / 2;
+        t.setColor4f(0.0F, 0.0F, 0.0F, 0.25F);
+        t.addVertex(-halfTextWidth - 1, -1, 0.0D);
+        t.addVertex(-halfTextWidth - 1, 8, 0.0D);
+        t.addVertex(halfTextWidth, 8, 0.0D);
+        t.addVertex(halfTextWidth, -1, 0.0D);
+        t.draw();
+        GLRenderer.popFrame();
+
+        sr.render(text, -halfTextWidth, 0).setColor(0x20ffffff).call();
+        if (!depthTest) GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.setDepthMask(true);
+        sr.render(text, -halfTextWidth, 0).setColor(0xFFFFFF).call();
+        GLRenderer.globalSetLightEnabled(true);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.popFrame();
+    }
+
     public @NotNull FontRenderer getFont() {
         return this.renderDispatcher.font;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 3393df3ae..57bdb44a4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -188,46 +188,6 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
         }
     }
 
-    protected void renderLivingLabel(final @NotNull TessellatorGeneral t, final @NotNull T entity, final @NotNull CharSequence text, final double x, final double y, final double z, final int maxDistance, final boolean depthTest) {
-        final float cameraDistance = (float) Minecraft.getMinecraft().activeCamera.distanceTo(entity);
-        if (cameraDistance > maxDistance) {
-            return;
-        }
-        final FontRenderer sr = getFont();
-        final float scale = 1.6f / 60f;
-
-        GLRenderer.pushFrame();
-        GLRenderer.modelM4f().translate((float) x, (float) y + entity.getHeadHeight() + 0.8f, (float) z);
-        GLRenderer.modelM4f().rotateY(Math.toRadians(-this.renderDispatcher.viewLerpYaw));
-        GLRenderer.modelM4f().rotateX(Math.toRadians(this.renderDispatcher.viewLerpPitch));
-        GLRenderer.modelM4f().scale(-scale, -scale, scale);
-        GLRenderer.globalSetLightEnabled(false);
-        GLRenderer.setDepthMask(false);
-        if (!depthTest) GLRenderer.disableState(State.DEPTH_TEST);
-        GLRenderer.enableState(State.BLEND);
-        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-
-        GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.COLOR);
-        t.startDrawingQuads();
-        final int halfTextWidth = sr.stringWidth(text) / 2;
-        t.setColor4f(0.0F, 0.0F, 0.0F, 0.25F);
-        t.addVertex(-halfTextWidth - 1, -1, 0.0D);
-        t.addVertex(-halfTextWidth - 1, 8, 0.0D);
-        t.addVertex(halfTextWidth, 8, 0.0D);
-        t.addVertex(halfTextWidth, -1, 0.0D);
-        t.draw();
-        GLRenderer.popFrame();
-
-        sr.render(text, -halfTextWidth, 0).setColor(0x20ffffff).call();
-        if (!depthTest) GLRenderer.enableState(State.DEPTH_TEST);
-        GLRenderer.setDepthMask(true);
-        sr.render(text, -halfTextWidth, 0).setColor(0xFFFFFF).call();
-        GLRenderer.globalSetLightEnabled(true);
-        GLRenderer.disableState(State.BLEND);
-        GLRenderer.popFrame();
-    }
-
     protected int getOverlayColor(final @NotNull T entity, final float partialTick) {
         return 0;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
index a3a303683..fe66802e4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
@@ -22,6 +22,10 @@ public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
         final float scale = 0.45f + (sizeRandom.nextFloat() * 0.35f);
         final float yRot = MathHelper.lerp(butterfly.yRotO, butterfly.yRot, partialTick);
         drawButterfly(tessellator, butterfly.tickCount, scale, yRot, x, y, z, partialTick, this.renderDispatcher.textureManager, getTexture(butterfly));
+
+        if (!butterfly.nickname.isEmpty()) {
+            renderLivingLabel(tessellator, butterfly, butterfly.getDisplayName(), x, y, z, 64, true);
+        }
     }
 
     @Override
